package aa4mm.core.coupling;

import aa4mm.core.type.SimulData;
import aa4mm.core.type.ValidData;
import aa4mm.core.type.ValidityInterval;



/**
 * this class is a representation of an interpretation artefact
 * @author bcamus
 *
 */

public abstract class InterpretationArtefact extends GenericCouplingArtefact{

	
	public synchronized void post(ValidData vd) {
        // assert (for debugging purposes)
        assert (vd != null) : "Don't put null validData to a coupling artefact!";
        assert (vd.getValidityInterval() != null) : "Don't put null validity interval to a coupling artefact!";
        assert (vd.getData() != null) : "Don't put null SimulData to a coupling artefact!";

       
        ValidityInterval v = vd.getValidityInterval();
        SimulData sd = vd.getData();
        SimulData interprete= interpretData(sd);
        
        savedData.put(v, interprete);
        notifyAll();

    }
	
	/**
	 * interpret the data
	 */
	public abstract SimulData interpretData(SimulData d);
	
}
