package aa4mm.core.type;

/**
 * This class represent time values and useful operation we can do on it
 * @author julien siebert
 */
public abstract class SimulTime {
	

	/**
	 * The time value
	 */
	protected double timeValue;
	
	/**
	 * Default constructor. It sets the timeValue to 0.0
	 */
	public SimulTime(){
		timeValue = 0.0;
	}
	
	/**
	 * Set the time value from a value given by a simulator.
	 * This method must implement the TIME OPERATION (i.e. translate from local model time to global virtual time)
	 * in order to exchange data with coherent and compatible time values.
	 * @param myModelTimeValue
	 */
	abstract public void setTimeFromModel(Object myModelTimeValue);
	
	/**
	 * @return the time value
	 */
	public double getTimeValue(){
		return timeValue;
	}

}
