package aa4mm.deployment.netlogo.type;


/**
 * A class to represent the data associated with a turtle in netlogo: heading, position, color...
 * @author siebertj
 */
public class NetlogoTurtle {

    /**
     * Specific Netlogo variable breed
     */
    private static final String breed = "turtle";
    /**
     * Specific Netlogo variable breeds
     */
    private static final String breeds = "turtles";
    /**
     * X coordinate of the netlogo turtle
     */
    private double xPos;
    /**
     * Y coordinate of the netlogo turtle
     */
    private double yPos;
    /**
     * id of the netlogo turtle
     */
    private double id;
    /**
     * heading of the netlogo turtle
     */
    private double heading;
    /**
     * color of the netlogo turtle
     */
    private double color;

    public NetlogoTurtle(double myXpos, double myYpos, double myId,
            double myHeading, double myColor) {
        this.xPos = myXpos;
        this.yPos = myYpos;
        this.id = myId;
        this.heading = myHeading;
        this.color = myColor;
    }

    public double getHeading() {
        return heading;
    }

    public double getColor() {
        return color;
    }

    public double getxPos() {
        return xPos;
    }

    public double getyPos() {
        return yPos;
    }

    public double getId() {
        return id;
    }

    public static String getBreed() {
        return breed;
    }

    public static String getBreeds() {
        return breeds;
    }

    @Override
    public String toString() {
        return "T:" + id + ";" + xPos + ";" + yPos + ";" + color;
    }

    public void setxPos(double xPos) {
        this.xPos = xPos;
    }

    public void setyPos(double yPos) {
        this.yPos = yPos;
    }

    public void setId(double id) {
        this.id = id;
    }

    public void setHeading(double heading) {
        this.heading = heading;
    }

    public void setColor(double color) {
        this.color = color;
    }
}
