package examples.multilevel.coupling;

import examples.multilevel.coupling.optics.*;
import examples.multilevel.data_type.*;

import java.util.ArrayList;
import java.util.TreeMap;

import aa4mm.core.coupling.GenericCouplingArtefact;
import aa4mm.core.type.*;


public class DownwardArtefact extends GenericCouplingArtefact{

	public synchronized void post(ValidData vd) {
        // assert (for debugging purposes)
        assert (vd != null) : "Don't put null validData to a coupling artefact!";
        assert (vd.getValidityInterval() != null) : "Don't put null validity interval to a coupling artefact!";
        assert (vd.getData() != null) : "Don't put null SimulData to a coupling artefact!";

       
        ValidityInterval v = vd.getValidityInterval();
        SimulData sd = vd.getData();
        
        TreeMap<PositionInfos, double[]> map=((PositionsFromMacroAgent)sd).getAgentIdGroupMap();
        ArrayList<PositionInfos> pos_list=new ArrayList<PositionInfos>();
        
        for(PositionInfos pos:map.descendingKeySet()){
        	
        	double vector[]=map.get(pos);
        	
        	pos.setX(pos.getX()+vector[0]);
        	pos.setY(pos.getY()+vector[1]);
        	pos.setHead(pos.getHead()+vector[2]);
        		
        	pos_list.add(new PositionInfos(pos.getId(),pos.getX(),pos.getY(),pos.getHead(),pos.getColor()));
        }
        	
        ValidityInterval interval=new ValidityInterval(v.getLowerBound(),v.getUpperBound());
        	
        savedData.put(interval, new PositionsFromDownwardArtefact(pos_list));
    
        notifyAll();
        
        


        
    }
	

}
