package examples.multilevel.coupling;

import java.util.ArrayList;
import java.util.TreeMap;

import examples.multilevel.coupling.optics.*;
import examples.multilevel.data_type.*;
import aa4mm.core.coupling.GenericCouplingArtefact;
import aa4mm.core.type.*;

public class DownwardArtefactTime extends GenericCouplingArtefact{

	public synchronized void post(ValidData vd) {
        // assert (for debugging purposes)
        assert (vd != null) : "Don't put null validData to a coupling artefact!";
        assert (vd.getValidityInterval() != null) : "Don't put null validity interval to a coupling artefact!";
        assert (vd.getData() != null) : "Don't put null SimulData to a coupling artefact!";

       
        ValidityInterval v = vd.getValidityInterval();
        SimulData sd = vd.getData();
        
        TreeMap<PositionInfos, double[]> map=((PositionsFromMacroAgent)sd).getAgentIdGroupMap();
        
        for(int i=0;i<4;i++){
        	ArrayList<PositionInfos> pos_list=new ArrayList<PositionInfos>();
        	for(PositionInfos pos:map.descendingKeySet()){
        		double vector[]=map.get(pos);
        	
        		pos.setX(pos.getX()+vector[0]/4);
        		pos.setY(pos.getY()+vector[1]/4);
        		pos.setHead(pos.getHead()+vector[2]/4);
        		
        		pos_list.add(new PositionInfos(pos.getId(),pos.getX(),pos.getY(),pos.getHead(),pos.getColor()));
        	}
        	
        	ValidityInterval interval=new ValidityInterval(v.getLowerBound()+i,v.getLowerBound()+i+1);
        	
        	savedData.put(interval, new PositionsFromDownwardArtefact(pos_list));
        	notifyAll();
        }
        
       
    }
	

}
