package examples.multilevel.coupling.optics;



/**
 * This object is used as a two inputs array
 * Typically to store the points and their distance to another point
 * @author p2pmail
 *
 */
public class CouplePointDistance implements Comparable<Object> {

	private PositionInfos pi;
	private double distance;
	
	public CouplePointDistance(PositionInfos pi, double distance) {
		
		this.pi = pi;
		this.distance = distance;
	}
	
	public PositionInfos getPi() {
		return pi;
	}

	public void setPi(PositionInfos pi) {
		this.pi = pi;
	}

	public double getDistance() {
		return distance;
	}

	public void setDistance(double distance) {
		this.distance = distance;
	}
	
	/**
	 * Used to compare points by distance instead of any hazardous way
	 */
	public int compareTo(Object o) {
		
		int result;
		CouplePointDistance cpd = (CouplePointDistance)o;
		
		if (this.getDistance() > cpd.getDistance())
			result = 1;
		else if (this.getDistance() < cpd.getDistance())
			result = -1;
		else
			result = 0;
		
		return result;
	}
	
	public String toString() {
		
		return "[point : "+pi+",distance : "+distance+"]";
	}
}
