package examples.multilevel.coupling.optics;

public class PositionInfos implements Comparable{
	
	private double id;
	private double x;
	private double y;
	private boolean inAGroup;
	private int group;
	private double head;
	private double color;

	
	public PositionInfos() {
		id = 0;
		x = 0;
		y = 0;
		group = 0;
		inAGroup = false;
	}
	
	public PositionInfos(double id, double x, double y, double hd) {
		this.id = id;
		this.x = x;
		this.y = y;
		inAGroup = false;
		head=hd;
		color=-1;
	}
	
	public PositionInfos(double id, double x, double y, double hd, double col){
		this.id = id;
		this.x = x;
		this.y = y;
		inAGroup = false;
		head=hd;
		color=col;
	}

	public int getGroup() {
		return group;
	}

	public void setGroup(int group) {
		this.group = group;
		setInAGroup(true);
	}

	public boolean isInAGroup() {
		return inAGroup;
	}

	public void setInAGroup(boolean inAGroup) {
		this.inAGroup = inAGroup;
	}

	public double getId() {
		return id;
	}

	public void setId(double id) {
		this.id = id;
	}

	public double getX() {
		return x;
	}

	public void setX(double x) {
		this.x = x;
	}

	public double getY() {
		return y;
	}

	public void setY(double y) {
		this.y = y;
	}
	
	public double getHead(){
		return head;
	}
	
	public void setHead(double hd){
		this.head=hd;
	}
	
	public double getColor(){
		return color;
	}
	
	public void setColor(double col){
		color=col;
	}
	
	public String toString() {
		return "<id : "+getId()+" \t ("+getX()+","+getY()+")>";
	}

	@Override
	public int compareTo(Object arg0) {
		int comp=0;
		if(this.id>((PositionInfos)arg0).getId()){
			comp=1;
		}else if(this.id<((PositionInfos)arg0).getId()){
			comp=-1;
		}
		return comp;
	}

}