package examples.multilevel.micro;

import examples.multilevel.data_type.PositionsFromDownwardArtefact;
import aa4mm.core.agent.GenericBasicMagent;
import aa4mm.core.type.SimulData;
import aa4mm.core.type.ValidData;
import aa4mm.deployment.netlogo.type.NetLogoTime;
import util.ConsoleLogger;


public class AgentFlockingManager extends GenericBasicMagent {

	private int maximumSimulationTime;

	

	public AgentFlockingManager(int maxSimTime) {
		super();
		this.cti = new NetLogoTime(-Double.MAX_VALUE);
		this.nti = new NetLogoTime(0.1);
		this.maximumSimulationTime = maxSimTime;
	}

	@Override
	public synchronized void start() {
		ConsoleLogger.getInstance().log("Flocking Model Init Start");
		initModel();
		ConsoleLogger.getInstance().log("Flocking Model Init Done!");

		/*
		 * Initialisation process
		 */
		// send output data to other models

		postOutputData();

		super.start();
	}

	
	@Override
	public void run() {

		ConsoleLogger.getInstance().log("Agent Flocking Starts the simulation");

		while (!endSimulation()) {

			// ConsoleLogger.getInstance().log("==== Agent Flocking Cycle Begin ====");

			// READ INPUT DATA 
			// read from all the coupling artefacts (ok, here we only have one
			// coupling artefact and we only have one data to read
			double simTime = getCurrentTime().getTimeValue();

			ValidData inputVd = getReadingArt().read(simTime);

		// MAY BE NO DATA
			// if the coupling artefact has given me an input data// nothing coming from i or e
			if (inputVd != null) {

				PositionsFromDownwardArtefact inputData = (PositionsFromDownwardArtefact) inputVd
						.getData();

				ConsoleLogger.getInstance()
						.log("Agent Flocking Set input data : "
								+ inputVd.toString());

				// set input data to the model

				setInputData(inputData);

			}
			else{
				System.out.println("no data read");
			}
			
			ConsoleLogger.getInstance().log("Agent Flocking Execute model");

			executeModel();

			ConsoleLogger.getInstance().log("Agent Flocking Post Output Data");

			// send output data to other models
			postOutputData();
			

		}

		// FilePrinter.getInstance().close();
	}

	@Override
	public boolean endSimulation() {
		return (getCurrentTime()).getTimeValue() >= maximumSimulationTime;
	}

	@Override
	public void readInputData() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setInputData(SimulData data) {
		// TODO Auto-generated method stub
		 modelArtefact.setInputData(data);
	}

	@Override
	public void finish() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setInitialParameters(String[] args) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void initializationProcess() {
		// TODO Auto-generated method stub
		
	}

	
		
	

}
