package util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;



public class FilePrinter {
	
	/*
	 * Singleton Pattern
	 */

	/**
	 * Instance of this class
	 */
	private static FilePrinter INSTANCE;
	
	/**
	 * Method to get the only instance of this class
	 * @return The only instance of this class (singleton)
	 */
	public static FilePrinter getInstance(){
		if(INSTANCE == null){
			INSTANCE = new FilePrinter();
		}
		return INSTANCE;
	}
	
	/**
	 * Private constructor
	 */
	private FilePrinter(){
			fileName = "default.txt";
	}
	
	/*
	 * End of
	 * Singleton Pattern
	 */
	
	private File file;
	private BufferedWriter writer;
	
	/**
	 * The name of the file to write in
	 */
	private String fileName;

	public String getFileName() {
		return fileName;
	}

	/**
	 * Change the name of the file
	 * @param name
	 */
	public void setFileName(String name) {
		this.fileName = name;
		try {
			file = new File(fileName);
			writer = new BufferedWriter(new FileWriter(file));
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	public void write(String str){
		try {
			writer.write(str+'\n');
		} catch (IOException e) {
			e.printStackTrace();
			System.err.println("please instanciate file and bufferedwriter by calling setFileName");
		}
	}
	
	public void close(){
		try {
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
